/*
 * Created on 2004-12-01
 *
 */
package edu.umk.mat.merdacz.JGFramework;

/**
 * At the moment all "outer" server protocol part of xml message
 * are attached here
 * TODO place it in parseRequest in ServerThread
 * 
 * @author Marcin Daczkowski
 *
 */
public class GameReplies {
    /**
     * Generates OK reply for given gameRequest type
     * 
     * @param id Idicates for which request reply will be produced
     * @param type Type of request for which reply will be generated
     * @return XML messages to send (on per line)
     */
    public static String replyOK(String type) {
        return         		
        		"<gameReply type=\"" + type + "\">" + "<ok/>" +
                "</gameReply>";
               
    }

    /**
     * Generates Failed reply for given gameRequest type, with given explaination
     * 
     * @param id Idicates for which request reply will be produced
     * @param type Type of request for which reply will be generated
     * @param reason Reason why failure occured
     * @return XML messages to send (on per line)
     */
    public static String replyFailed(String type, String reason) {
        return 				        
				"<gameReply type=\"" + type + "\">" +
                	"<failed reason=\"" + reason + "\"/>" + 
                "</gameReply>";
               
    }

    /**
     * Generates reply with given content
     * 
     * @param id
     * @param type
     * @param content
     * @return
     */
    public static String reply(String type, String content) {
        return         		
        		"<gameReply type=\"" + type + "\">" +
        		content +
                "</gameReply>";
               
    }    
    
    /**
     * Sends messgae to all but not "name" player in actual game
     * 
     * @param type Which type of request caused this broadcast
     * @param content What should be wrapped in broadcast reply
     * @return XML to broadcast
     */
    public static String gameBroadcast(String type, String content) {
        return 
        	"<gameBroadcast type=\"" + type + "\">" + 
        	content +
        	"</gameBroadcast>";
    }

}
