/*
 * Created on 2004-11-17
 *
 */
package edu.umk.mat.merdacz.JGServer;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import edu.umk.mat.merdacz.JGServer.config.PluginCfg;
import edu.umk.mat.merdacz.JGServer.config.ServerCfg;

/**
 * HashMap of {@link Game} wrapper. Thread safe.
 * 
 * @author Marcin Daczkowski
 *
 */
public class Games {

    /**
     * 
     */
	HashMap games;
	
	/**
	 * 
	 */
	Object lockGames = new Object();
	
	/**
	 * 
	 */
	public Games(ServerCfg cfg, String roomsFromDb) {
	    games = new HashMap();
		// go through plugins (from ConfigurationResolver cfg) 
		try {
			List pl = cfg.getPluginNamesList();
			Iterator i = pl.iterator();
			String p;
		    
			while (i.hasNext()) {
			    p = (String) i.next();
			    
			    PluginCfg pc = cfg.getPlugin(p);

		        System.out.println("Loading plugin \"" + pc.getName() + "\"");
		        
			    games.put(pc.getName(), 
			            new Game(pc.getName(), Class.forName(pc.getClazz())
			                    , roomsFromDb));
			    
			    System.out.println("");
		    
			}

		} catch (ClassNotFoundException e) {
			// TODO
			System.out.println(e);
		}
	}
	
	/**
	 * @param gameName
	 * @return
	 */
	public Game getGameByName(String gameName) {
	    synchronized (lockGames) {
	        return (Game) games.get(gameName);
	    }

	}
}
