/*
 * Created on 2004-11-16
 *
 */
package edu.umk.mat.merdacz.JGServer;

import java.io.DataOutputStream;
import java.io.IOException;


/**
 * In memory Player representation. 
 * <p>
 * It doesn't need to be synchronized because (except sendMessage)
 * methods are called only from one thread.
 * 
 * @author Marcin Daczkowski
 *
 */
public class Player {

	private String loginName;
	private Room room;
	private DataOutputStream dout;
	
	private Object syncDout = new Object();
	
	public Player(DataOutputStream dout) {
		this.dout = dout;
		room = null; // to be sure
		
	}
	
	public boolean joinRoom(Room room) {
		if ( room.join(this) ) {
		    this.room = room;
		    return true;
		} else {
		    return false;
		}
	}
	public void leaveRoom() {
	    room.leave(this);
	    room = null;
	}
		
    /**
     * @param loginName
     */
    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }
    
	/**
	 * @return
	 */
	public String getLoginName() {
		return loginName;
	}

	/**
	 * @return
	 */
	public String getPlayerAvatar() {
	    // get avatar from NXD and return
	    return "<avatar>not implemented yet</avatar>";
	}
	
	/**
	 * @return
	 */
	public Room getRoom() {
        return room;
	}
	
	public void sendMessage(String xmlToSend) throws IOException {
	    synchronized (syncDout) {
	        dout.writeUTF(xmlToSend);
	    }
	}
	  
	/**
	 * TODO delete it
	 */
	public String toString() {
	    return "<player>" + loginName + "</player>";	    
	}
	
	public String toXml() {
	    return "<player>" + loginName + "</player>";	    
	}	

}
