/*
 * Created on 2004-11-17
 *
 */
package edu.umk.mat.merdacz.JGServer;

import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

/**
 * HashMap of {@link Player} wrapper. Thread safe. 
 * 
 * @author Marcin Daczkowski
 *
 */
public class Players {
	
    private Object lockPlayers = new Object();
    
	private HashMap players;
	
	/**
	 * 
	 */	
	public Players() {
		players = new HashMap();
		// read some data from xml database and put it to rooms AL 
	}
	
	/**
	 * @param p
	 */
	public void addPlayer(Player p) {
	    synchronized (lockPlayers) {
	        players.put(p.getLoginName(), p);
	        //update NXD
	    }
	}
	
	/**
	 * @param p
	 */
	public void delPlayer(Player p) {
	    synchronized (lockPlayers) {
	        players.remove(p.getLoginName());
	        // update NXD
	    }
	}
	
	/**
	 * @param name
	 * @return
	 */
	public boolean checkPlayer(String name) {
	    synchronized (lockPlayers) {
	        return players.containsKey(name);
	    }
	    
	}
	
	/**
	 * @return
	 */
	public int size() {
	    synchronized (lockPlayers) {
	        return players.size();
	    }
	}
	
    /**
     * @param xmlToSend
     * @param playerToOmit
     * @throws IOException
     */
    public void broadcast(String xmlToSend, Player playerToOmit) throws IOException {
        synchronized (lockPlayers) {
            Set aKeySet = players.keySet();
            Iterator it = aKeySet.iterator();
            Player p;
            while (it.hasNext()) {
                p = (Player) players.get(it.next());
                // equals can only operate on non-null's
                if ( playerToOmit != null ) {
                    if (! p.equals(playerToOmit)) {
                        p.sendMessage(xmlToSend);
                    }
                } else {
                    p.sendMessage(xmlToSend);
                }
            }
            
        }
    }	
    
    
    public void sendMessage(String toPlayer, String xmlToSend) throws IOException {
        synchronized (lockPlayers) {
            Player p = (Player) players.get(toPlayer);
            p.sendMessage(xmlToSend);
        }
        
    }
    
    /**    
     * @return
     */
    public String getPlayersInXml() {
        String s = "";
        synchronized (lockPlayers) {
            Set aKeySet = players.keySet();
            Iterator it = aKeySet.iterator();
            Player p;
            while (it.hasNext()) {
                p = (Player) players.get(it.next());
                s = s + p.toString();
            }
        }
        
        return s;
    }
	

    /**
     * @param name
     * @return
     */
    public Player getPlayerByName(String name) {
        synchronized (lockPlayers) {
            return (Player) players.get(name);
        }
    }
    
    
}
