/*
 * Created on 2004-11-17
 *
 */
package edu.umk.mat.merdacz.JGServer;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

/**
 * HashMap of {@link Room} wrapper. Thread safe.
 *  
 * @author Marcin Daczkowski
 */
public class Rooms {
	
	/**
	 * 
	 */
    private HashMap rooms;
	
	/**
	 * 
	 */
	private Class gamelet;
	
	/**
	 * 
	 */
	private Object syncRooms = new Object();
	
	/**
	 * @param gamelet
	 */
	public Rooms(Class gamelet) {
	    rooms = new HashMap();
		this.gamelet = gamelet;
		
	}
	
	/**
	 * @param r
	 */
	public void addRoom(Room r) {
	    r.setGamelet(gamelet);
	    
	    synchronized (syncRooms) { 
	        //rooms.add(r);
	        rooms.put(r.getName(), r);
	    }
	    
		// update NXD
	}
	
	/**
	 * @param r
	 */
	public void delRoom(Room r) {
	    synchronized (syncRooms) {
	        //rooms.remove(r);
	        rooms.remove(r.getName());
	    }      
	    		
	    // update NXD	
	}
	
	
	/**
	 * @param name
	 * @return
	 */
	public Room getRoomByName(String name) {
	    synchronized (syncRooms) {
	        return (Room) rooms.get(name);
	    }
	}

	
	/**
	 * @return String which consists of all r.toString()'s 
	 */
	public String toString() {
	    String s = ""; 
	    
	    Set aKeySet = rooms.keySet();
	    Iterator it = aKeySet.iterator();	    
	    
	    while (it.hasNext()) {
	        Room r = (Room) rooms.get(it.next());
	        s = s + r.toString();
	    }       
	    
	    return s;
	}
}
