/*
 * Created on 2004-11-19
 *
 */
package edu.umk.mat.merdacz.JGServer.config;

/** 
 * Boxing class for cfg which must be passed to CfgLoader.
 * We need to box beacuse CfgLoader fills the passed cfg
 * 
 * @author Marcin Daczkowski
 *
 */
public class CfgBox {
    ServerCfg cfg;
    
    /** 
     * The default constructor implies using setCfg
     * before processing configuration file.
     *
     */
    public CfgBox() {
        cfg = new ServerCfg();        
    }      
    
    /**
     * Constructs boxing class and automaticly embeds 
     * given {@link ServerCfg} with it. 
     * 
     * @param cfg configuration object to be embeded
     */
    public CfgBox(ServerCfg cfg) {
        this.cfg = cfg;
    }

    /**
     * @return Embeded configuration object
     */
    public ServerCfg getCfg() {
        return cfg;
    }
    
    /**
     * This method may be usefull when Server 
     * needs to be reloaded (in example when new plugin 
     * has been deployed)
     * 
     * @param cfg configuation object to be emebeded
     */
    public void setCfg(ServerCfg cfg) {
        this.cfg = cfg;
    }
}
