/*
 * Created on 2004-12-02
 *
 */
package edu.umk.mat.merdacz.utils;

import java.util.LinkedList;

/**
 * @author Marcin Daczkowski
 *
 */
public class Queue {
	private LinkedList items;

	/**
	 * Creats an empty queue
	 */
	 
	public Queue()
	{
		items = new LinkedList();
	}
	
	/**
	 * Inserts a new element at the rear of the queue.
	 * @param element element to be inserted.
	 */
	
	public Object enqueue (Object element)
	{
		items.add (element);
		return element;
	}
	
	/**
	 * Removes the element at the top of the queue.
	 * @return the removed element.
	 * @throws EmptyQueueException
	 * @throws EmptyQueueException if the queue is empty.
	 */

	public Object dequeue () throws EmptyQueueException 
	{
		if (items.size()== 0)	
			throw new EmptyQueueException() ;
		return items.removeFirst();		
	}

	/**
	 * Inspects the element at the top of the queue without removing it.
	 * @return the element at the top of the queue.
	 * @throws EmptyQueueException
	 * @throws EmptyQueueException if the queue is empty.
	 */
	
	public Object front () throws EmptyQueueException 
	{
		if (items.size()== 0)	
			throw new EmptyQueueException() ;
		return items.getFirst();	
	}
	
	/**
	 * @return the number of elements at the queue.
	 */

	public int size()
	{
		return items.size();
	}

	/**
	 * @return true of the queue is empty.
	 */	

	public boolean empty()
	{
		return (size()==0);
	}

	/**
	 * Removes all elements at the queue.
	 */	

	public void clear ()
	{
		items.clear();
	}        

}
